	;
	; 2048 - coded by csabo of lod, 2014-04-06
	; 2048 octaluxe - enhanced by luca of fire, 2019-11-02
	;
	; feel free to use to source.
	; be sure to check out the various included modules,
	; they are meant to be reused.
	;
	org $0aa6-2
	dw  $0aa6
	
	org $1001
	
;	dw $1019,0
;	db $9e,$c2,"(44)",$ac,"256",$aa,$c2,"(43)",$aa,"26"
;	db 0,0,0

; music addressing
init	= $3682
play1	= $28ff
play2	= $2aa7
vfade	= play1-$3
vmaster	= play1-$2

pos_corner = $0c30
grid_width = 4
grid_height = 4
grid = $04fc
;	db 0,0,0,0
;	db 0,0,0,0
;	db 0,0,0,0
;	db 0,0,0,0

dst			= $d0
dstc			= $d2
src			= $d4
winw			= $d6
winh			= $d7
winc			= $d8

xloop			= $d9
yloop			= $da
xdest			= $db
ydest			= $dc
current_tile		= $dd
valid_move		= $de
win_flag		= $df
medal			= $ed
medalc			= $ee
shield			= $ef
tilecolor		= $f0
sfx_pickon		= $f1
sfx_1sttime		= $f2
sfx_counter		= $f3
switch_music		= $f4
switch_sfx		= $f5
xtemp			= $f6
bounce_temp		= $f7
sfx_temp		= $f8

; random
rand			= $e0	; 32 bit

; keyboard
keyb_ptr		= $e4
keyb_lastkey		= $e6
keyb_repeatcnt		= $e7
keyb_shift		= $e8
keyb_repeat_init	= 20	; constant
keyb_repeat		= 4	; constant

; highscore
hs_ptr			= $e9
;hs_data			= $1c00
hs_scores		= 10
hs_namelen		= 5
hs_scorelen		= 5
; used by I/O code	= $02
; used by I/O code	= $03

; string input
si_curpos		= $eb	; zp
si_maxlen		= $ec	; zp
si_space		= $ae	; const: default padding character

; music
;kp_zp0 		= $08
;kp_zp0+1		= $09
;kp_zp1 		= $07


drawwindow	macro xp, yp, width, height, color
	lda #($0c00+xp+yp*40) & 255
	sta dst
	lda #($0c00+xp+yp*40) >> 8
	sta dst+1
	lda #width
	sta winw
	lda #height
	sta winh
	lda #color
	sta winc
	jsr draw_border
endm

setcolor	macro xp, yp, width, height, color
	lda #($0800+xp+yp*40) & 255
	sta dst
	lda #($0800+xp+yp*40) >> 8
	sta dst+1
	;
	ldy #width
	ldx #height
	;
	lda #color
	sta winc
	jsr set_color
endm

copygfx		macro xp, yp, width, height, sourceaddr
	lda #($0c00+xp+yp*40) & 255
	sta dst
	lda #($0c00+xp+yp*40) >> 8
	sta dst+1
	;
	ldy #width
	ldx #height
	;
	lda #sourceaddr & 255
	sta src
	lda #sourceaddr >> 8
	sta src+1
	;
	jsr copy_gfx
endm
	
start
;	lda #$40		; ted check!
;	sta $ff16		; make sure that:
;	lda $ff16		; $ff16 can be read/written
;	cmp #$c0		; highest bit is always set
;	beq can_start
;	;
;	ldx #$22		; print message and quit
;	ldy #$34		; (vic20/c64 compatible)
;qt1	lda ($2b),y
;	jsr $ffd2
;	iny
;	dex
;	bpl qt1
;	rts
;	;
;	db "this program requires a c16/plus4.",13
	;
can_start
;	SEI		; set before in exomizer
;	STA $ff3e	; set before in exomizer
	;
;	JSR screenoff	; set before in exomizer
;	LDA #$59	; set before in exomizer
;	STA $ff15	; set before in exomizer
;	STA $ff19	; set before in exomizer       	
	;
	
	ldx #$ff
	txs
	;
	ldx #$3d	; relocate stuff under $0800	
reloc6	lda $0c00,x	; crosscopying to save memory!
	sta $0220,x
	lda $0b0b,x
	sta $025d,x
	lda $0b1c,x	; crosscopying to save memory!
	sta $026e,x
	lda $0b82,x
	sta $02ad,x
	dex
	bpl reloc6
	ldx #$18
reloc5	lda $0c4a,x
	sta $07c0,x
	lda $0bc0,x
	sta $0200,x
	lda $0bc7,x	; crosscopying to save memory!
	sta $0207,x
	dex
	bpl reloc5
	ldx #$14
reloc4	lda $0b5a,x
	sta $0191,x
	lda $0b6d,x	; crosscopying to save memory!
	sta $01a4,x
	dex
	bpl reloc4
	inx		; LDX $00
	stx $ff17	
reloc3	lda $0c63,x
	sta $0708,x
	inx
	cpx #$ac
	bne reloc3
	ldx #$00
reloc2	lda $0f5d,x
	sta $055c,x
	inx
	cpx #$8b
	bne reloc2
	ldx #$00
reloc1  lda $0e0f,x
	sta $0332,x
	lda $0e5d,x
	sta $0380,x
	lda $0d0f,x
	sta $0600,x
	inx
	bne reloc1
	ldx #$07	; sublogo space char
reloc7	lda #$00
	sta $0700,x
	lda $0be0,x
	sta $04e7,x
	lda $0c3d,x
	sta $04ef,x
	lda $0c42,x
	sta $04f4,x
	dex
	bpl reloc7
	ldx #$64
reloc8	lda $0aa6,x
	sta $0a,x
	dex
	bpl reloc8
	stx sfx_pickon	; init sfx flags
	stx sfx_1sttime
	;
	jsr initrandom
        ;
	jsr clear_screen
	;
	lda #$88
	jsr setff07
	and #$40
	beq pal
	dec ntscfix1+1
	lda #$fe
	sta ntscfix2+1
pal	
	lda $ff12
	and #$03
	ora #$c0
	sta $ff12
	lda #$38
	sta $ff13
	lda #$71
	sta $ff16
	lda #$00
	sta $ff17
	;	
	jsr screenon
	;
	jsr clearhighscores
	;
	jsr loader
	;
new_game
	jsr screenoff
	jsr clear_screen
	;
	sei	
	lda #irqtitle4 & 255	; set it up
	sta $0314
	lda #irqtitle4 >> 8
	sta $0315
	lda #$a2	; protection against a possible $a3 state from previous irq
	sta $ff0a
	lda #$cc	; set breakpoint
	sta $ff0b
	cli		; activate screen irqs
; one char of the same charset has been used to be
; differently modified in both intro and game
magic_char = $c7
	ldx #$06
	lda #$6d
	sta charset+magic_char*8+1,x
	dex
	bpl *-4
	lda #$61
	sta charset+magic_char*8
	;
; the game starts with sfx on and music on, then
; it automatically remembers the last ingame choice
mind_sfx
	lda #$00
	sta switch_sfx
mind_music	
	lda #$00
	sta switch_music
	;
build_title
	drawwindow 4, 0, 30, 11, $17
	ldx #$4f
bt1	lda #$1f	; color sublogo window
	sta $0918,x
	lda #$e0	; clear with blank @ $ff13 = 0
	sta $0d18,x
	dex
	bpl bt1
	lda #$c0	; reset bracket @ $ff13 = 0
	sta $0d1c
	sta $0d44
	lda #$c1
	sta $0d3a
	sta $0d62
	lda #$f1	; set debris color
	sta $0903
	sta $097b
	jsr screenon
	ldx #$00
bt2	stx xtemp
	ldy #$08	; wait 9 frames
	jsr sync
	dey
;	cpy #$00	; y must be #$00 to be used in the tiles draw!!
	bne bt2+4
	lda #$01		; sfx: put 1x
	jsr ignite_sfx
	lda titletiles,x
	jsr draw_new_tile
	ldx xtemp
	inx
	cpx #$04
	bne bt2
	;
	jsr sublogo
	drawwindow 6, 10, 26, 5, $19
	ldx #$18
bt3	lda credits,x
	sta $0de7,x
	lda credits+$19,x
	sta $0de7+$28,x
	dex
	bpl bt3
;	copygfx 9, 12, 21, 2, credits
;	drawwindow 4, 19, 30, 3, $19
;	copygfx 4, 19, 31, 4, intro
	ldx #$00
bt4	lda #$19
	sta $0ad4,x
	sta $0ad4+$88,x
	inx
	cpx #$88
	bne bt4
	ldx #$1e
bt5	lda intro,x
	sta $0ed4,x
	lda intro+$1f,x
	sta $0ed4+$28,x
	lda intro+$3e,x
	sta $0ed4+$50,x
	lda intro+$5d,x
	sta $0ed4+$78,x
	lda intro+$7c,x
	sta $0ed4+$c8,x
	lda intro+$9b,x
	sta $0ed4+$f0,x
	dex
	bpl bt5
	;
	jsr waitspace
	stx rand+0			; initialize random number based on keypress
	sty rand+1
	;
	jsr screenoff
	jsr clear_screen
	;
	sei
;	jsr music
	jsr init		; Knaecketracker only !!	
	lda #irqgame1 & 255	; set it up
	sta $0314
	lda #irqgame1 >> 8
	sta $0315
	lda #$38	; set breakpoint
	sta $ff0b
	sta $ff13	; irqtitle could have picked up $00 for $ff13!
	lda #$94
	jsr setff07
	cli		; activate music irqs
	;
; one char of the same charset has been used to be
; differently modified in both intro and game
	ldx #$06
	lda #$00
	sta charset+magic_char*8+1,x
	dex
	bpl *-4
	;
;	lda #$00			; clear win
	sta win_flag
	lda #$a0			; set medal to none
	sta medal
	lda #$01			; ask for a second initial tile
	sta valid_move
	lda #$0c
	sta charset+magic_char*8
	;
	jsr clear_grid
	jsr clear_score
	jsr draw_grid
	jsr draw_stars
	jsr set_sides
	jsr screenon
	jsr sync		; never change! draw tiles at the right rasterline
	jsr add_random
	jsr draw_new_tile
	;
game_loop
	jsr update_score
	jsr draw_grid
	;
	lda win_flag
	bne won
	;
	lda valid_move
	beq gl1
	;
	jsr medal_check
	;
	lda #$00		; sfx: slide and put 2x
	jsr ignite_sfx
	;
;	jsr wait_5_frames
	jsr sync		; never change! draw tiles at the right rasterline
	jsr add_random
	jsr draw_new_tile
	;
gl1	jsr is_gameover
	bcs gameover
	;
afterswitch
	lda #key_table & 255
	ldx #key_table >> 8
	jmp keyboard

won	
	lda #$06
	jsr medal7_won
won_game
	ldx #$00
	lda themepark,x
	beq congrats		; check for #$00 as exit
	jsr fentry
	inc won_game+1
	jmp won_game
	
congrats 
	ldx #$00
	stx won_game+1
	;
	lda #$c6
	sta medal
	;
	drawwindow 9, 11, 20, 2, $77
	ldx #$10
	lda congratulations,x
	sta $0deb,x
	dex
	bpl *-7
;	copygfx 11, 12, 17, 1, congratulations	
	;
	jsr waitspace
	;
gameover
	lda switch_sfx			; remind ingame sfx
	sta mind_sfx+1                                           
	lda switch_music		; remind ingame sfx
	sta mind_music+1
	ldx #$00			; force sfx on, music off
	stx switch_sfx
	dex
	stx switch_music	
	;               
	
	lda win_flag
	bne no_gameover_sequence
	lda #$0e			; sfx: game over 2x
	jsr ignite_sfx
	jsr sync
	setcolor 8, 1, 23, 23, $49
	lda sfx_pickon			; wait to finish the gameover sfx
	bpl *-2
	;
no_gameover_sequence	
	jsr checkhighscore
	bmi not_on_highscore_list
	;
	drawwindow 12, 8, 14, 7, $71
	copygfx 14, 10, 11, 4, enteryourname
	;
	lda #hs_namelen
	sta si_maxlen
	;
	jsr stringinputclear
	jsr stringinput
	;
	jsr inserthighscore
	;
not_on_highscore_list
	drawwindow 11, 3, 16, 17, $11
	;
	ldx #$0c
hs1	lda highscores,x
	sta $0d25-80,x
	lda savescores,x
	sta $0d25+440,x
	dex
	bpl hs1
	;
	jsr displayhighscores
	;
	lda #$0e	; set it up
	sta $0314
	lda #$ce
	sta $0315	
	jsr savehit
	;
	jmp new_game
	
savehit
	lda #$7f
	jsr querykeyboard
	and #$10		; query keyboard for "space"
	beq waitspace-1
	jsr check_double_j
	beq waitspace-1
	lda xtemp
	and #$40
	beq waitspace-1		; query for fire button		
scheck	lda #$fd
	jsr querykeyboard
	and #$20		; query keyboard for "s"
	bne savehit
	jsr saver		; save scores by pressing "s"
	rts
	
waitspace
	ldx #$00		; two counters, will have random value
	ldy #$00		; based on how long space/fire is pressed
	;
ws0	inx
	;
	lda #$7f
	jsr querykeyboard
	and #$10		; query keyboard for "space"
	beq ws1
	;
	jsr check_double_j
	beq ws2
	lda xtemp
	and #$40
	bne ws0
	;
ws2	iny
	;
	jsr check_double_j
	beq ws2
	lda xtemp
	and #$40
	beq ws2
	;
	rts
	;
ws1	iny
	;
	lda #$7f
	jsr querykeyboard
	and #$10
	beq ws1
	;
	rts
	
querykeyboard
	sta $fd30
queryjoystick
	sta $ff08
	lda $ff08
	rts

check_double_j
	lda #$ff	; shut up keyboard
	sta $fd30
	lda #$f9
	jsr queryjoystick
	sta xtemp
	and #$80
	rts

syncx3
	jsr sync
syncx2	
	jsr sync
	jsr sync
	rts

; useless if fadein is used
;wait_5_frames
;	ldx #$05
;	db $2c
sync
;	ldx #$00
	lda #$e4		; raster at 24th line only after 1st title!
wf1	cmp $ff1d
	bne *-3
	cmp $ff1d
	beq *-3
;	dex
;	bpl wf1
	rts
	;
	; print score on screen
	;
update_score
	ldx #hs_scorelen-1
us1	lda score,x
	clc
	adc #$6c		; set score digits
	sta $0c9e-hs_scorelen,x
	clc
	adc #10
	sta $0c9e+40-hs_scorelen,x
	dex
	bpl us1
	rts
	
	;
	; add a random tile to the grid
	;	
add_random
ar1	jsr getrandom
	pha
	and #$03		; lowest two bits are x coord
	tax
	stx xloop
	pla
	lsr a
	lsr a
	and #$03		; next two bits are y coord 
	tay
	sty yloop
	jsr get_tile		; ensure tile is empty
	bne ar1			; otherwise generate new random coords
	;
	jsr getrandom
	cmp #$e7		; 90% of time it's 2 tile
	bcs ar2
	;
	lda #$01		; 2 tile
	db $2c
ar2	lda #$02		; 4 tile
	ldx xloop
	ldy yloop
	jsr set_tile
	rts
	
	;
	; draw the entire grid
	;
draw_grid
	;
	jsr sync
	;
;	INC $ff19
	ldx #$00
	ldy #$00
	;
dg1	stx xloop
	sty yloop
	jsr get_tile
	ldx xloop
	ldy yloop
	jsr draw_one_tile
	;
	ldx xloop
	ldy yloop
	inx
	cpx #grid_width
	bne dg1
	ldx #$00
	iny
	cpy #grid_height
	bne dg1
	;
;	DEC $ff19
	rts
	
	;
	; clear the grid (all blank tiles)
	;
clear_grid
;	db $ab,$00	; LAX #$00
	ldx #$00
	lda #$00
cg1	sta grid,x
	inx
	cpx #grid_width*grid_height
	bne cg1
	rts
	
	; x,y = pos
	; a = tile
set_tile
	pha
	stx xtemp	; save the temporary xloop
	tya
	asl a
	asl a
	sta st1+1
	txa
	clc
st1	adc #$00
	tax
	pla
	sta grid,x
	rts
	;
;st2	db 0	

	; x,y = pos
	; return: a = tile	
get_tile
	tya
	asl a
	asl a
	sta gt1+1
	txa
	clc
gt1	adc #$00
	tax
	lda grid,x
	rts
	
	; x,y = pos
	; a = tile
draw_one_tile
	pha
	;
	jsr get_tile_screen_pos
	;
	pla
	pha
	tax
	lda tile_colors,x
	sta tilecolor
	;
	ldx #15		; 16 ordered chars
dot1	txa
	ldy tilemap,x
	sta (dst),y
	lda tilecolor
	sta (dstc),y
	dex
	bpl dot1
	;
	pla		; 9 core char unrolled
	tay
	ldx tile_pointer,y
	ldy #$29

; using JSRs toward a generic code performing in some cases several unneeded
; instructions is intentionally time consumptive but memory saving because it
; still lies into one frame by JSR sync on draw_grid
	jsr coredraw	 
	jsr coredraw
	jsr coredraw
	ldy #$51
	jsr coredraw	 
	jsr coredraw
	jsr coredraw
	ldy #$79
	jsr coredraw	 
	jsr coredraw
	jsr coredraw
	;	
;	lda tile_text,x
;	sta (dst),y
;	lda tilecolor
;	sta (dstc),y
;	inx
;	iny
;	lda tile_text,x
;	sta (dst),y
;	lda tilecolor
;	sta (dstc),y
;	inx
;	iny
;	lda tile_text,x
;	sta (dst),y
;	lda tilecolor
;	sta (dstc),y
;	inx
;	ldy #$51
;	lda tile_text,x
;	sta (dst),y
;	lda tilecolor
;	sta (dstc),y
;	inx
;	iny
;	lda tile_text,x
;	sta (dst),y
;	lda tilecolor
;	sta (dstc),y
;	inx
;	iny
;	lda tile_text,x
;	sta (dst),y
;	lda tilecolor
;	sta (dstc),y
;	inx
;	ldy #$79
;	lda tile_text,x
;	sta (dst),y
;	lda tilecolor
;	sta (dstc),y
;	inx
;	iny
;	lda tile_text,x
;	sta (dst),y
;	lda tilecolor
;	sta (dstc),y
;	inx
;	iny
;	lda tile_text,x
;	sta (dst),y
;	lda tilecolor
;	sta (dstc),y
	rts		
	
coredraw
	lda tile_text,x
	sta (dst),y
	lda tilecolor
	sta (dstc),y
	inx
	iny
	rts

whitedraw	
	lda tile_text,x
	sta (dst),y
	lda #$79	; initial white
	sta (dstc),y
	inx
	iny
	rts
	
draw_new_tile
	ldx xtemp	; loads the temporary xloop
	;
	pha
	;
	jsr get_tile_screen_pos
	;
	pla
	pha
	tax
	lda tile_colors,x
	sta winh	; use winh as temporary deposit due to no windows opened while playing
	and #$0f
	ora #$70
	sta tilecolor
	;
	ldx #15
	;
dot1a	txa
	ldy tilemap,x
	sta (dst),y
	lda #$79	; initial white
	sta (dstc),y
	dex
	bpl dot1a
	;
	pla
	tay
	ldx tile_pointer,y
	ldy #$29
dot4a	jsr whitedraw
	cpy #$2c
	bne dot4a
	ldy #$51
dot5a	jsr whitedraw
	cpy #$54
	bne dot5a
	ldy #$79
dot6a	jsr whitedraw
	cpy #$7c
	bne dot6a
	;
	jsr sync
	;
	; --- fadein loop
	;	
	lda tilecolor
dot3a	ldy #$00
dot8a	sta (dstc),y
	iny
	cpy #$05
	bne dot8a
	ldy #$28
dot9a	sta (dstc),y
	iny
	cpy #$2d
	bne dot9a
	ldy #$50
dotaa	sta (dstc),y
	iny
	cpy #$55
	bne dotaa
	ldy #$78
dotba	sta (dstc),y
	iny
	cpy #$7d
	bne dotba
	ldy #$a0
dotca	sta (dstc),y
	iny
	cpy #$a5
	bne dotca
	;
	jsr sync	 
	;
	lda tilecolor
	cmp winh	; use winh as temporary deposit due to no windows opened while playing
	bne dotda
	rts
dotda	sec
	sbc #$10	; luminance down
	sta tilecolor
	bne dot3a	; a is never #$00, it's jmp dot3a
			; reuse of the same temporary byte
;dot2a	db 0		

dst_add_40
	lda #40
dst_add	clc
	adc dst
	sta dst
	sta dstc
	bcc *+6
	inc dst+1
	inc dstc+1
	rts

	; x,y = pos
	; modifies a
	; -> dst = address
get_tile_screen_pos
	stx gtp1+1
	tya
	asl a
	asl a
	clc
gtp1	adc #$00
	asl a
	tax
	lda pos_table,x
	sta dst
	sta dstc
	lda pos_table+1,x
	sta dst+1
	and #$fb
	sta dstc+1
	rts

is_gameover
	ldx #$00
igo2	lda grid,x
	beq igo1		; empty space = no game over
	inx
	cpx #grid_width*grid_height
	bne igo2
	;
	; --- check if anything can be merged
	;
	ldx #$00
	ldy #$00
igo3	stx xloop	
	sty yloop
	jsr get_tile
	sta current_tile
	;
	ldx xloop
	inx
	cpx #grid_width
	beq igo4
	ldy yloop
	jsr get_tile
	cmp current_tile
	beq igo1		; yes, two same tiles are side-by-side
	;
igo4	ldx xloop
	ldy yloop
	iny
	cpy #grid_height
	beq igo5
	jsr get_tile
	cmp current_tile
	beq igo1		; yes, two same tiles are below each other
	;
igo5	ldx xloop
	ldy yloop
	inx
	cpx #grid_width
	bne igo3
	;
	ldx #$00
	iny
	cpy #grid_height
	bne igo3
	;
	sec
	rts
	
igo1	clc
	rts
	
moveleft
	lda #$00
	sta valid_move
	;
	ldy #$00
ml1	sty yloop
	;
	ldx #$00
	stx shield
ml3	stx xloop
	;
	ldy yloop
	jsr get_tile
	beq ml6			; empty tile, nothing to do
	;
	; -- move tile down (if possible)
	;
	sta current_tile
	;
	ldx xloop
	stx xdest
	ldy yloop
	sty ydest
	;
ml4	ldy ydest
	dec xdest
	ldx xdest
;	cpx #$ff		; no empty space, continue loop
;	beq ml2
	bmi ml2
	jsr get_tile
	bne ml5
	;
	jsr move_tile
	jmp ml4
	;	
ml5	cmp current_tile
	bne ml2
	;
	lda shield
	bne ml2
	jsr merge_tile
	;
	lda #$01
	db $2c
ml2	lda #$00
	sta shield
	;
ml6	ldx xloop
	inx
	cpx #grid_width
	bne ml3
	;
	ldy yloop
	iny
	cpy #grid_height
	bne ml1
	;
	jmp game_loop
			
moveup
	lda #$00
	sta valid_move
	;
	ldx #$00
mu1	stx xloop
	;
	ldy #$00
	sty shield
mu3	sty yloop
	;
	ldx xloop
	jsr get_tile
	beq mu6			; empty tile, nothing to do
	;
	; -- move tile down (if possible)
	;
	sta current_tile
	;
	ldx xloop
	stx xdest
	ldy yloop
	sty ydest
	;
mu4	ldx xdest
	dec ydest
	ldy ydest
;	cpy #$ff		; no empty space, continue loop
;	beq mu2
	bmi mu2
	jsr get_tile
	bne mu5
	;
	jsr move_tile
	jmp mu4
	;	
mu5	cmp current_tile
	bne mu2
	;
	lda shield
	bne mu2
	jsr merge_tile
	;
	lda #$01
	db $2c
mu2	lda #$00
	sta shield
	;
mu6	ldy yloop
	iny
	cpy #grid_height
	bne mu3
	;
	ldx xloop
	inx
	cpx #grid_width
	bne mu1
	;
	jmp game_loop
	
moveright
	lda #$00
	sta valid_move
	;
	ldy #$00
mr1	sty yloop
	ldx #$00
	stx shield
	;
	ldx #grid_width-2
mr3	stx xloop
	;
	ldy yloop
	jsr get_tile
	beq mr6			; empty tile, nothing to do
	;
	; -- move tile down (if possible)
	;
	sta current_tile
	;
	ldx xloop
	stx xdest
	ldy yloop
	sty ydest
	;
mr4	ldy ydest
	inc xdest
	ldx xdest
	cpx #grid_width		; no empty space, continue loop
	beq mr2
	jsr get_tile
	bne mr5
	;
	jsr move_tile
	jmp mr4
	;	
mr5	cmp current_tile
	bne mr2
	;
	lda shield
	bne mr2
	jsr merge_tile
	;
	lda #$01
	db $2c
mr2	lda #$00
	sta shield
	;
mr6	ldx xloop
	dex
	bpl mr3
	;
	ldy yloop
	iny
	cpy #grid_height
	bne mr1
	;
	jmp game_loop
	
movedown
	lda #$00
	sta valid_move
	;
	ldx #$00
md1	stx xloop
	ldy #$00
	sty shield
	;
	ldy #grid_height-2
md3	sty yloop
	;
	ldx xloop
	jsr get_tile
	beq md6			; empty tile, nothing to do
	;
	; -- move tile down (if possible)
	;
	sta current_tile
	;
	ldx xloop
	stx xdest
	ldy yloop
	sty ydest
	;
md4	ldx xdest
	inc ydest
	ldy ydest
	cpy #grid_height	; no empty space, continue loop
	beq md2
	jsr get_tile
	bne md5
	;
	jsr move_tile
	jmp md4
	;	
md5	cmp current_tile
	bne md2
	;
	lda shield
	bne md2
	jsr merge_tile
	;
	lda #$01
	db $2c
md2	lda #$00
	sta shield
	;
md6	ldy yloop
	dey
	bpl md3
	;
	ldx xloop
	inx
	cpx #grid_width
	bne md1
	;
	jmp game_loop
	
	;
	; move one tile from xloop/yloop to xdest/ydest
	;
move_tile
	inc valid_move
	;
	ldx xloop
	ldy yloop
	lda #$00		; blank to original place
	jsr set_tile
	;
	ldx xdest
	ldy ydest
	lda current_tile	; tile to new place
	jsr set_tile
	;
	ldx xdest
	stx xloop
	ldy ydest
	sty yloop
	;
	rts
	
merge_tile
	inc valid_move
	;
	ldx xloop
	ldy yloop
	lda #$00
	jsr set_tile
	;
	ldx xdest
	ldy ydest
	jsr get_tile
	;
	clc
	adc #$01
	pha
	ldx xdest
	ldy ydest
	jsr set_tile
	;
	pla
	pha
	asl a
	asl a
	asl a
	tax
	ldy #$00
mt1	lda tile_score,x
	sta scoreaddsub,y
	inx
	iny
	cpy #hs_scorelen
	bne mt1
	jsr addscore
	;
	pla
	cmp #11			; 2048 tile?
	bne mt2
	;
	lda #$01
	sta win_flag		; won
	rts
	;
	; --- flashing stars
	;
mt2	cmp #2			; under 4?
	bmi mt2-1		; no flashing star
fentry	tay
	;
	jsr ignite_sfx		; sfx: stars 2x
	tya
	;
	sec
	sbc #$02
	asl a
	tax
	lda tile_colors,y	; remember star color
	sta mt5+1		; in order to cmp it later on
	lda locatestarcolor,x
	ldy locatestarcolor+1,x
	sta dstc
	sty dstc+1
	ldx #$01		; reading table for 5 (-1) chars long word
mt3	jsr score_flash		; while starts go lighter (X: 0-5)
	ldy #$28
	lda (dstc),y 
	clc			; light up
	adc #$10
	bmi mt6
	sta (dstc),y
	bne mt3			; jmp mt3
mt6	sec			; light down
	sbc #$10
mt4	lda (dstc),y
	bmi mt5 
	sec
	sbc #$10
mt5	cmp #$c9		; compare with the color to be reached
	bmi no_star_color	; if lower, no color
	sta (dstc),y
	; score flash and medal flash are longer than flashing stars
no_star_color	
	jsr score_flash		; while starts go darker (X: 6-8)
	cmp #$12		; if the rightmost char is $12...
	beq mt2-1
	bne mt4			; jmp mt4
		
addscore
	ldx #hs_scorelen-1
as1	lda score,x
	clc
	adc scoreaddsub,x
	cmp #$0a
	bcc nooverflow
	;
	cpx #$00
	beq scoreover999999
	inc scoreaddsub-1,x
	sec
	sbc #$0a
nooverflow
	sta score,x
	dex
	bpl as1
	;
	rts
	
scoreover999999
	lda #$09
	db $2c
scorebelowzero
	lda #$00	
	ldx hs_scorelen-1
sbz1	sta score,x
	dex
	bpl sbz1
	;
	rts
	
clear_score
	ldx #hs_scorelen-1
	lda #$00
cs1	sta score,x
	dex
	bpl cs1
	rts
	
	;
	; clears the high score list
	;
clearhighscores
	lda #hs_data & 255		; reset pointer
	sta hs_ptr
	lda #hs_data >> 8
	sta hs_ptr+1
	;
	ldx #hs_scores-1		; loop through each score
	;
chs0	ldy #$00
	;
	lda #$00			; "0"
chs1	sta (hs_ptr),y			; fill score
	iny
	cpy #hs_scorelen
	bne chs1
	;
	tya
	jsr hs_ptr_add			; inc pointer
	;
	ldy #$00
	lda #$a0			; empty medal
	sta (hs_ptr),y
	;
	iny				; inc pointer
	tya
	jsr hs_ptr_add
	;
	ldy #$00
	lda #$ae			; "."
chs2	sta (hs_ptr),y			; fill name
	iny
	cpy #hs_namelen
	bne chs2
	;
	tya
	jsr hs_ptr_add			; inc pointer
	;
	dex
	bpl chs0
	;
	rts 
	
displayhighscores
	jsr hs_ptr_reset
	;
	lda #$25
	sta dst
	lda #$0d
	sta dst+1
	;
	lda #$00
	sta yloop
	;
dhs0	ldy #$00
dhs2	lda (hs_ptr),y			; score
	ora #$b0
	sta (dst),y
	iny
	cpy #hs_scorelen
	bne dhs2
	;
	tya
	jsr hs_ptr_add
	iny
	tya
	jsr dst_add
	;
	; ---
	;
	lda dst
	sta dstc
	lda dst+1
	and #$fb
	sta dstc+1
	ldy #$00
	lda (hs_ptr),y			; medal
	sta (dst),y
	and #7
	tay
	lda medal_color,y
	ldy #$00
	sta (dstc),y
	;	
	; ---
	;
	lda #$01
	jsr hs_ptr_add
	lda #$02
	jsr dst_add
	;

dhs1	lda (hs_ptr),y			; name
	ora #$80
	sta (dst),y
	iny
	cpy #hs_namelen
	bne dhs1
	;
	tya
	jsr hs_ptr_add
	;
	lda #(40-3-hs_scorelen)		; 3 spaces for medal
	jsr dst_add
	;
	; ---
	;
	inc yloop
	lda yloop
	cmp #hs_scores
	bne dhs0
	;
	rts	
	
displaystring
	ldx #$00
ds01	lda si_string,x
	sta $0e19,x
	lda #$a0
	sta $0e19+40,x
	inx
	cpx si_maxlen
	bne ds01
	;
	lda #$a0
	sta $0e19+40,x
	;
	lda #$9f			; cursor while entering hiscore      
	ldx si_curpos
	sta $0e19+40,x
	
	rts
	
	;
	; draw border
	;
draw_border
	lda dst
	sta dstc
	lda dst+1
	and #$fb
	sta dstc+1
	;
	ldy #$00
	lda border_chars
	jsr set_borders
	iny
	;
	ldx winw
	dex
	dex
db1	lda border_chars+1
	jsr set_borders
	iny
	dex
	bpl db1
	;
	lda border_chars+2
	jsr set_borders
	;
	jsr dst_add_40
	;
	ldx winh
	dex
	dex
	stx yloop
	;
	; ---
	;
db3	ldy #$00
	lda border_chars+3
	jsr set_borders
	iny
	;
	ldx winw
	dex
	dex
db2	lda border_chars+4
	jsr set_borders
	iny
	dex
	bpl db2
	;
	lda border_chars+5
	jsr set_borders
	;
	jsr dst_add_40
	;
	dec yloop
	bpl db3
	;
	; ---
	;
	ldy #$00
	lda border_chars+6
	jsr set_borders
	iny
	;
	ldx winw
	dex
	dex
db4	lda border_chars+7
	jsr set_borders
	iny
	dex
	bpl db4
	;
	lda border_chars+8
	jsr set_borders
        ;
	rts

set_borders
	sta (dst),y
	lda winc
	sta (dstc),y
	rts
	
clear_screen
	jsr sync
	;
;	ldy #$00
;	sty dst
;	lda #$0c
;	sta dst+1
;	ldx #$03
;	lda #$a0		; blank
;csc1	sta (dst),y
;	iny
;	bne csc1
;	inc dst+1
;	dex
;	bpl csc1
;	;
;	sty dstc
;	lda #$08
;	sta dstc+1
;	ldx #$03
;	lda #$00
;csc2	sta (dstc),y
;	iny
;	bne csc2
;	inc dstc+1
;	dex
;	bpl csc2
;	rts

; shorter and saves $30 bytes
	ldx #$00
csc	lda #$00
	sta $0800,x
	sta $0900,x
	sta $0a00,x
	sta $0ae8,x
	lda #$a0
	sta $0c00,x
	sta $0d00,x
	sta $0e00,x
	sta $0ee8,x
	inx
	bne csc
	rts

copy_gfx
	sty winw
	;
cgr2	ldy winw
	dey
cgr1	lda (src),y
	sta (dst),y
	dey
	bpl cgr1
	;
	jsr dst_add_40
	;
	lda winw
	clc
	adc src
	sta src
	bcc *+4
	inc src+1
	;
	dex
	bne cgr2
cgr3	rts

set_color
	sty winw
	;
scl2	ldy winw
	dey
scl1	lda winc
	sta (dst),y
	dey
	bpl scl1
	;
	jsr dst_add_40
	;
	dex
	bne scl2
scl3	rts
	
medal_check
	lda #$00
	sta medalc
	;
	ldx #$f
mc3	lda grid,x
	cmp #7
	bmi mc1
	sec
	sbc #$06
	cmp #3
	bne mc2
	lda #4
	db $2c
mc2	cmp #4
	bne mc5
	lda #8
mc5	ora medalc
	sta medalc
mc1	dex
	bpl mc3
	; --- check medal state (#7 excluded for 2048)
	ldx medalc
	lda medal_state,x
	cmp medal
	bmi scl3		; rts
	beq scl3		; rts
	sta medal
	and #$07
medal7_won
	asl a
	tax
	lda medals_draw,x
	sta ml+1
	lda medals_draw+1,x
	sta ml+2
	jsr medals_flash
	;
	lda switch_sfx		; if sfx are off, the code doesn't wait any sfx
	bmi ml
	lda #$0c		; sfx: shine 2x
	jsr ignite_sfx
	lda sfx_pickon
	bpl *-2
	;
ml	jsr $2020		; changed onthefly
	rts

set_sides
	ldx #$05
	lda medals,x
	sta $0c01,x
	dex
	bpl *-7	
;	copygfx 1, 0, 6, 1, medals
	copygfx 39-hs_scorelen-1, 0, 5, 1, score_
	ldx #$07
ss7	lda leftwing,x
	sta $0c28,x
	lda rightwing,x
	sta $0c47,x
	dex
	bpl ss7	
;	copygfx 0, 1, 8, 1, leftwing
;	copygfx 39-hs_scorelen-3, 1, 8, 1, rightwing
	lda #$cf
	sta $0c57
	lda #$2f
	sta $0857
	sta $086f
	lda #$d1
	sta $0c6f
	ldx #$07
	ldy #$00
ss1	lda wings_color,x
	sta $0828,x
	sta $0847,y
	lda #$12
	sta $0800,x
	sta $0820,x
	lda #$6f
	sta $0898,x
	sta $08c0,x
	iny
	dex
	bpl ss1
	;
; preset the matrix colors for all the hidden items on screem
	;	
	ldx #$02	; silver medals
ss2	lda #$49	; and their top
	sta $08c9,x
	sta $091c,x
	sta $09e1,x
	sta $0a5c,x
	sta $0b49,x
	sta $0bc4,x
	lda #$29	; gold medal middle
	sta $0aca,x
	lda #$1a
	sta $0aac,x
	lda #$1b
	sta $0941,x
	lda #$1c
	sta $0a81,x
	lda #$1e
	sta $096c,x
	dex
	bpl ss2
	ldx #$05
	lda #$49
ss3	sta $08f1,x
	sta $0a09,x
	sta $0a31,x
	sta $0b71,x
	sta $0b99,x
	dex
	bpl ss3
	;
	lda #$1f
	sta $0852
	lda #$3f
	sta $0852+$28
	sta $0852+$50
	lda #$1d
	sta $087d
	lda #$3d
	sta $087d+$28
	sta $087d+$50
	ldx #$02
ss5	lda #$3b
	sta $0969,x
	sta $0969+$28,x
	sta $0969+$50,x
	lda #$3e
	sta $0994,x
	sta $0994+$28,x
	sta $0994+$50,x
	lda #$3c
	sta $0aa9,x
	sta $0aa9+$28,x
	sta $0aa9+$50,x
	sta $0aa9+$78,x
	lda #$3a
	sta $0ad4,x
	sta $0ad4+$28,x
	sta $0ad4+$50,x
	sta $0ad4+$78,x
	dex
	bpl ss5
;	setcolor 1, 9, 3, 3, $3b
;	setcolor 4, 10, 3, 3, $3e
;	setcolor 1, 17, 3, 4, $3c
;	setcolor 4, 18, 3, 4, $3a
	;
	ldx #$04	; gold medal
ss4	lda ribbon,x
	sta $0911+$28*1,x
	sta $0911+$28*2,x
	sta $0911+$28*3,x
	sta $0911+$28*4,x
	sta $0911+$28*5,x
	sta $0911+$28*6,x
	sta $0911+$28*7,x
	sta $0911+$28*8,x
	sta $0911+$28*9,x
	sta $0911+$28*10,x
	lda ribbondark,x
	sta $0911+$28*0,x
	lda bigmedal+0*5,x
	sta $0af1+0*$28,x
	lda bigmedal+1*5,x
	sta $0af1+1*$28,x
	lda bigmedal+2*5,x
	sta $0af1+2*$28,x
	lda bigmedal+3*5,x
	sta $0af1+3*$28,x
	lda bigmedal+4*5,x
	sta $0af1+4*$28,x
	dex
	bpl ss4
	;
	ldx #$08	; audio text
	lda #$47
ss6	sta $0bcf,x
	dex
	bpl ss6
	rts
	
draw_stars
	ldx #$0c
	ldy #$08
ds1	lda #$9e		; star
	sta $0cfd,x
	sta $0ded,x
	sta $0edd,x
	lda stars,y
	sta $08fd,x
	dey
	lda stars,y
	sta $09ed,x
	dey
	lda stars,y
	sta $0add,x
	dey
	;
	txa
	sec
	sbc #$06
	tax
	bpl ds1
	;
	rts

score_flash
	jsr syncx2
	;
	lda tagflash+1,x
	sta $0824
	lda tagflash+2,x
	sta $0823
	lda tagflash+3,x
	sta $0822
	lda tagflash+4,x
	sta $0821
	lda tagflash,x
	sta $0825
	inx		
	rts
	
medals_flash
	ldy #$03
	ldx #$00	
mf	lda tagflash,x
	sta $0801
	lda tagflash+1,x
	sta $0802
	lda tagflash+2,x
	sta $0803
	lda tagflash+3,x
	sta $0804
	lda tagflash+4,x
	sta $0805
	lda tagflash+5,x
	sta $0806
	jsr syncx2
	inx
	cpx #$0b
	bne mf
medals_ping
	lda #$06
	jsr ignite_sfx		; sfx: 128-256-512 x2
	;
	inc medals_ping+1
	dey
	bpl mf-2
	lda #$06
	sta medals_ping+1
	rts

	; a = $ff07	
setff07
	sta setora+1
	lda $ff07
	and #$40
setora	ora #$00
	sta $ff07
	rts

ignite_sfx
	; a = sfx
	; switch_sfx:  $ff=off, $00=on
	; sfx_pickon:  $ff=off, $xx=play xx
	; sfx_1sttime: $ff=off, $xx=set sfx
	sta sfx_pickon		; set sfx (x) on
	sta sfx_1sttime		; set 1st time on
	lda #$00
	sta sfx_counter
	rts

play_sfx	
	lda sfx_pickon		; no play when off
	bmi play_sfx-1		; rts
	lda sfx_1sttime
	bmi play_sfx_continue
	cmp #$0e		; 'coz both sfx_pickon and sfx_1sttime share the same value >>$ff
	beq play_sfx_0e
	;
	lda sfx_pickon
	asl a
	tax
	lda sfx_ff0e_index,x
	sta setff0e+1
	lda sfx_ff0e_index+1,x
	sta setff0e+2
	lda sfx_ff0f_index,x
	sta setff0f+1
	lda sfx_ff0f_index+1,x
	sta setff0f+2
	lda sfx_ff10_index,x
	sta setff10+1
	lda sfx_ff10_index+1,x
	sta setff10+2
	lda sfx_ff11_index,x
	sta setff11+1
	lda sfx_ff11_index+1,x
	sta setff11+2
	lda sfx_ff12_index,x
	sta setff12+1
	lda sfx_ff12_index+1,x
	sta setff12+2
	;
	lda #$ff
	sta sfx_1sttime		; set 1st time off ($ff)
	;	
play_sfx_continue
	lda sfx_pickon
	cmp #$0e
	beq play_sfx_0e_continue	
	ldy sfx_counter
setff11	db $bf,$ff,$ff		; lax $ffff,y
	bne play		; check if sfx has finished
setff11_0e	
	stx $ff11		; shut off
	dex
	stx sfx_pickon		; set sfx off ($ff)
	lda #$8d		; all BITs turn back to STA
	sta staff12
	sta staff0e
	sta staff10
	sta staff0f
	rts
	
play_sfx_0e
	lda #$ff
	sta sfx_1sttime		; set 1st time off ($ff)
	;
	ldx #$04
psfx1	
	lda play_sfx_0e_init,x
	sta play_sfx_0e_play,x
	dex
	bpl psfx1
	;
play_sfx_0e_continue
	inc sfx_counter
	lda play_sfx_0e_play+4
	sta $ff12
	lda play_sfx_0e_play+2
	sta $ff10
	dec play_sfx_0e_play
	lda play_sfx_0e_play
	sta $ff0e
	dec play_sfx_0e_play+1
	lda play_sfx_0e_play+1
	sta $ff0f
	ldx play_sfx_0e_play+3
	lda sfx_counter
	and #$0f
	bne psfx2
	dex
	stx play_sfx_0e_play+3
psfx2	stx $ff11
	cpx #$30
	bne play_sfx_0e-1	; RTS
	ldx #$00
	beq setff11_0e		; JMP setf11_0e	

play_sfx_0e_init
	db $8f,$9f,$7f,$38,$c2
play_sfx_0e_play		
        db $8f,$9f,$7f,$38,$c2	

play
	lda $ff11
	and #$50		; $60 = $20 so cut it from audio to force $40 when sfx plays it
	sta sfx_temp
	txa
	ora sfx_temp  
	sta $ff11
	inc sfx_counter
setff12	lda $ffff,y		; if $ff then modify voice2 only
	cmp #$ff
	bne staff12		; ok, perform $ff12 and $ff0e!
	lda #$2c		; swap STA with BIT
	sta staff12
	sta staff0e
	bne setff10		; JMP setff10
staff12	sta $ff12		
setff0e	lda $ffff,y
staff0e	sta $ff0e	
setff10	lda $ffff,y	        ; if $ff then modify voice1 only
	bpl staff10		; ok, perform $ff10 and $ff0f!
	lda #$2c		; swap STA with BIT
	sta staff10
	sta staff0f
	bne setff0f		; JMP setff10 
staff10	sta $ff10
setff0f	lda $ffff,y
staff0f	sta $ff0f
	rts
	
music_key
; the main program switches the music on when F1 is pressed at the
; right time, leaving vfade to fade it up; the music player switches
; the music off when it fades down and vmaster reaches the zero.
	lda vmaster
        beq volup
        cmp #$0f
        beq voldown
        lda vfade
        eor #$fe
        bne revfade
volup  	sta switch_music	; switch music on when F1 is pressed
	lda #$01
 db $2c				; BIT $XXXX
voldown	lda #$ff	
revfade	sta vfade 	        
        clc
        adc switch_sfx
        beq at5
        bpl at4
        cmp #$ff
        beq at6
	bne at7
	;
sfx_key
	lda #$ff
	sta sfx_pickon
	lda switch_sfx
	eor #$ff
	sta switch_sfx
        beq at8
        lda vmaster
        beq at7
        bne at5
at8     lda vmaster
        beq at6	
at4	ldx #$00		; set audio music+sfx
 db $2c				; BIT $XXXX	
at5	ldx #$02		; set audio music
 db $2c				; BIT $XXXX        
at6	ldx #$04		; set audio sfx
 db $2c				; BIT $XXXX	
at7	ldx #$06		; set audio silence
	lda audio_text,x
	sta at1+1
	lda audio_text+1,x
	sta at1+2
	jsr audio_print
	ldy #$0a
at3	jsr syncx3
	ldx #$08
at2	lda audio_text_color,y
	sta $0bcf,x
	dex
	bpl at2
	dey
	bpl at3
	jsr syncx3
	lda #space9 & 255
	sta at1+1
	lda #space9 >> 8
	sta at1+2
	jsr audio_print	
	jmp afterswitch

audio_print
	ldx #$08
at1	lda $ffff,x
	sta $0fcf,x
	dex
	bpl at1
	rts
	        
sublogo_bounce
	lda #$01		; sfx: put 1x
	jsr ignite_sfx
	;
	inc lulo+1
	inc ldlo+1	
	dec rulo+1
	dec rdlo+1
	
	dec bounce_temp
	bne still_bounce
deys	dey
	dey
	dey
	dey
	ldx bounces+1
	dex
	lda #$ea	; nops
	sta deys,x
	stx bounces+1
still_bounce
	dey		; always non zero
	jmp bounce_out

; works with bo hi-nibbles if tables are align 256!
sublogo
	lda #rightup & 255		; (re)set pointers
;	ldy #rightup >> 8
	sta rulo+1
;	sty sl2+2
	lda #rightdown & 255
;	ldy #rightdown >> 8
	sta rdlo+1
;	sty sl2+8
	lda #(leftup+$14) & 255
;	ldy #(leftup+$14) >> 8
	sta lulo+1
;	sty sl2+14
	lda #(leftdown+$14) & 255
;	ldy #(leftdown+$14) >> 8
	sta ldlo+1
;	sty sl2+20
        
	ldy #$00
sl1	
	ldx #$13
rulo	lda rightup,x
	sta $0d18+$14,x
rdlo	lda rightdown,x
	sta $0d18+$14+$28,x
lulo	lda leftup+$14,x
	sta $0d18,x
ldlo	lda leftdown+$14,x
	sta $0d18+$28,x
	dex
	bpl rulo
	iny
	cpy #$14
	bmi shake-2		; to reach bmi tocenter
	lda bounce_temp
	bne sublogo_bounce
bounces	
	lda #$04
	sta bounce_temp
	bne sublogo_bounce	; forth if zero after having bounced
todesynch
	cpy #$15
	bpl shake		; readdress to tocenter: shake works 1st time only
	db $24,(shake-3 - delay)	; bmi desynch-1 switched off by bit: go to iny, no delay!
delay
	ldx #$4f		; delay works 1st time only
	jsr sync
	dex
	bpl delay+2
	iny
        bne tocenter		; jmp tocenter

shake
	lda #$0d		; sfx: grind 1x
	jsr ignite_sfx
	;
	ldx #$0f
sh1	stx xtemp		; use winw as temporary deposit due to no windows opened while playing
	txa
	lsr a
	lsr a
	tax
	lda debristable,x
	sta $0d03
	lda debristable+4,x
	sta $0d03+$78
	ldx xtemp		; use winw as temporary deposit due to no windows opened while playing
	lda $ff07
	clc
	adc shaketable,x
	sta $ff07
	;
	lda #$3f		; color in the midst
midst_colors	
	ldx #$02		; restore color in the midst
	sta $092a,x
	sta $0952,x
	dex
	bpl midst_colors+2
	lda #$6f
	sta $092b
	sta $0953
	jsr sync
	ldx xtemp		; use winw as temporary deposit due to no windows opened while playing
	dex
	bpl sh1
noshake	
	cpy #$1b
	bne tocenter
        ;
        lda #$0b		; sfx: long shine 1x
	jsr ignite_sfx
	;
	ldy #$0f		; sublogo flash
fl2	ldx #$0e
fl1	lda sublogo_flash,y
	sta $0924,x
	cpy #$09
	bpl *+5
	sec
	sbc #$10
	sta $0924+$28,x
	dex
	bpl fl1
	jsr syncx2
	dey
	bpl fl2
	
	lda #$c3		; set sync at 24th line after 1st time only
	sta sync+1
	lda #(noshake+2 - delay); readdress to tocenter: shake works 1st time only
	sta todesynch+3
	lda #$30		; place bmi
	sta todesynch+4
null	
	rts
	
;	lda #$ff
; db $cf,sl2+13 & 255,sl2+13 >> 8
;	bne *+5
;	dec sl2+14
;	lda #$ff
; db $cf,sl2+19 & 255,sl2+19 >> 8
;	bne *+5
;	dec sl2+20

tocenter
	dec lulo+1
	dec ldlo+1
	inc rulo+1
;	bne *+5
;	inc sl2+2
	inc rdlo+1
;	bne *+5
;	inc sl2+8

bounce_out
	
	jsr sync
	
	jmp sl1

irqtitle1
	pha
	lda ($00,x)	; 6 cycles
	lda ($00,x)	; 6 cycles
	lda ($00,x)	; 6 cycles
	db $14,$00	; 4 cycles: nop $00,x
	lda #$00
        sta $ff13
	;
	lda #irqtitle2 & 255	; set it up
	sta $0314
	lda #irqtitle2 >> 8
	sta $0315
	lda #$4a	; set breakpoint
        bne standard_a_irq	; jmp standard_a_irq
	
irqtitle2
	pha
	lda ($00,x)	; 6 cycles	
	lda $ff12
	and #$03
	ora #$c0
	sta $ff12
        lda #$38
        sta $ff13
	lda #irqtitle3 & 255	; set it up
	sta $0314
	lda #irqtitle3 >> 8
	sta $0315
	lda #$4e		; set breakpoint
standard_a_irq
	sta $ff0b
	;
	inc $ff09	; acknowledge
	;
	pla
	jmp $ce0e
	
irqtitle3
	pha
	lda $ff07
	and #$47
	ora #$80
	sta $ff07
;	jsr play_sfx
	lda #irqtitle4 & 255	; set it up
	sta $0314
	lda #irqtitle4 >> 8
	sta $0315
	lda #$cc
	bne standard_a_irq	; jmp standard_a_irq
	
irqtitle4
	pha
	lda #$94
	jsr setff07
	jsr play_sfx
	lda #irqtitle1 & 255	; set it up
	sta $0314
	lda #irqtitle1 >> 8
	sta $0315
	lda #$3a		; set breakpoint
	bne standard_a_irq	; jmp standard_a_irq
	
irqgame1
	pha
	txa
	pha
	tya
	pha
	;
;	INC $ff19
;	INC $ff15
	;
	lda switch_music
	bmi nomusic1
;	jsr music+3
;	jsr music+6
	jsr play1		; Knaecketracker only !!
	jsr play2
nomusic1
	lda #irqgame2 & 255	; set it up
	sta $0314
	lda #irqgame2 >> 8
	sta $0315
	lda #$86
	;
        bne standard_axy_irq	; jmp standard_axy_irq        
	
irqgame2
	pha
	txa
	pha
	tya
	pha
	;
;	INC $ff19
;	INC $ff15
	;
	lda switch_sfx
	bmi nosfx1
	jsr play_sfx
nosfx1
	lda #irqgame3 & 255	; set it up
	sta $0314
	lda #irqgame3 >> 8
	sta $0315
	lda #$d4
	;
standard_axy_irq		
	sta $ff0b
	;
	inc $ff09
	;
;	DEC $ff15
;	DEC $ff19
	;
	pla
	tay
	pla
	tax
	pla
	jmp $ce0e
		
irqgame3
	pha
	txa
	pha
	tya
	pha
	;
;	INC $ff19
;	INC $ff15
	;
	lda switch_music
	bmi nomusic2
;	jsr music+6
	jsr play2		; Knaecketracker only !!
nomusic2
	lda #irqgame4 & 255	; set it up
	sta $0314
	lda #irqgame4 >> 8
	sta $0315
ntscfix1
	lda #$a3
	sta $ff0a
ntscfix2	
	lda #$22
	;
	bne standard_axy_irq	; jmp standard_axy_irq
	
irqgame4
	pha
	txa
	pha
	tya
	pha
	;
;	INC $ff19
;	INC $ff15
	lda switch_sfx
	bmi nosfx2
	jsr play_sfx
nosfx2
	lda #irqgame1 & 255	; set it up
	sta $0314
	lda #irqgame1 >> 8
	sta $0315
	lda #$a2
	sta $ff0a
	lda #$38
	;
	bne standard_axy_irq	; jmp standard_axy_irq

;tile				; useless due to the tile gfx
;	db $00,$01,$02,$03,$04,$05,$06,$07
;	db $08,$09,$0a,$0b,$0c,$0d,$0e,$0f

	cmap
	cmap " ",$a0,$a1,$a2,$a3,$a4,$a5
	cmap "'",$a7,$a8,$a9,$aa,$ab,$ac,$ad,$ae,$af,$b0,$b1,$b2,$b3,$b4,$b5,$b6,$b7,$b8,$b9,$ba,$bb
	cmap "=",$bd
	cmap "?",$bf
	cmap "a",$81,$82,$83,$84,$85,$86,$87,$88,$89,$8a,$8b,$8c,$8d,$8e,$8f,$90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9a
	
intro		; $ba
	db "cursor keys/joy move the tiles."
	db "when tiles with the same number"
	db "touch,they merge into one. when"
	db "a 2048 tile is created,you win!"
	db "f1/f2 swap audio while playing."
	db "esc quits the game at any time."
	
	include "keyboard.asm"		; the only keyboard handler you'll ever need
	; moved!
;	include "random.asm"		; pseudo-random numbers
	include "highscore.asm"		; a high score handler
	include "string_input.asm"	; nice string input with insert/delete, etc.
	
	include "medals_gfx.asm"
			
loader
	include "loader_seq.asm"

; sound effects

	include "sfx.asm"

hs_data		= $0123
;hs_data		; $6e
;	db $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
;	db $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
;	db $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
;	db $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
;	db $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
;	db $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
;	db $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff

	org $28e4
music	
	include "music.asm"

; --------------------------------
; reloc8

	org $0aa6
	
; $0a
	include "saver_seq_000a.asm"

saver		= $0a

; --------------------------------
; reloc6tris

	org $0b0b
	
; $025d        
	include "random.asm"		; pseudo-random numbers	

screenoff	= $02a3
	lda #$0b
	db $2c			; BIT
screenon	= $02a6	
	lda #$1b
	sta $ff06
	rts


; --------------------------------
; reloc4bis

titletiles	= $0191
;titletiles	; $04
	db 1,$c,2,3

stars		= $0195
;stars		; $09
	db $3d,$39,$3a,$2e,$3b,$3e,$2b,$2a,$3c

locatestarcolor	= $019e
;locatestarcolor	; $12
	dw $08d5,$08db,$08e1
	dw $09c5,$09cb,$09d1
	dw $0ab5,$0abb,$0ac1

border_chars	= $01b0
;border_chars	; $09
	db $07,$07,$07
	db $9c,$a0,$9b
	db $07,$07,$07

; --------------------------------
; reloc6bis

;	org $0b82
        
        cmap
	cmap " ",$a0,$a1,$a2,$a3,$a4,$a5
	cmap "'",$a7,$a8,$a9,$aa,$ab,$ac,$ad,$ae,$af,$b0,$b1,$b2,$b3,$b4,$b5,$b6,$b7,$b8,$b9,$ba,$bb
	cmap "=",$bd
	cmap "?",$bf
	cmap "a",$81,$82,$83,$84,$85,$86,$87,$88,$89,$8a,$8b,$8c,$8d,$8e,$8f,$90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9a

medal_color	= $02ad	
;medal_color	; $07
	db $37,$35,$33,$36,$34,$32,$71		; empty and 256 are the same

tile_pointer	= $02b4	
;tile_pointer	; $0d			; points to the beginning of any 3x3 tile core gfx
	db 00,09,18,27,36,45,54,63,72,81,90,99,108

name		= $02c1
;name		; $05
	db "     "
si_string = name

medals		= $02c6
;medals		; $06	
	db "medals"

score_		= $02cc	
;score_		; $05 
	db "score"
	
highscores	= $02d1
;highscores	; $0d
	db " high scores "

savescores	= $02de
;savescores	; $0d	
	db "hit s to save"	

; --------------------------------
; reloc5
	
;	org $0bc0

medal_state	= $0200
;medal_state	; $10	
	db $a0,$a0,$c0,$c1,$c2,$c2,$c3,$c3	; no 2048
	db $c4,$c4,$c4,$c4,$c5,$c5,$c5,$c5
	
; both for SCORE (5) and MEDALS (6), the first starts from X=$01 then
; checks the rightmost character as the last to be #$12, the second uses
; three fixed cycles till 6x$12
tagflash	= $0210
;tagflash	; $10
	db $12,$12,$12,$12,$12,$22,$42,$72
	db $42,$22,$12,$12,$12,$12,$12,$12
	
audio_text	= $04e7	
;audio_text	; $08
	dw audio_music_sfx,audio_music,audio_sfx,audio_silence	

; --------------------------------

;	org $0be8
	
leftwing
	db $c7,$c8,$c9,$ca,$cb,$cc,$cd,$ce
	
rightwing
	db $d0,$d2,$d3,$d4,$a6,$bc,$d5,$be
	
wings_color
	db $5c,$5a,$6a,$6c,$6a,$6d,$4f,$3f
	
; --------------------------------
; reloc6

;	org $0c00

audio_music_sfx	= $0220
;audio_music_sfx	; $24
	db "music+sfx"
audio_music	= $0229
	db "  music  "	
audio_sfx	= $0232
	db "   sfx   "	
audio_silence	= $023b
	db " silence "

themepark	= $0244
;themepark	; $19
	db 2,3,4,7,10,9,8,5,2,3,4,7,10,9,8,5,2,3,4,7,10,9,8,5,0	
	
; --------------------------------
; reloc7

;	org $0c3d

tile_colors	= $04ef
;tile_colors	; $0d
	db $2f,$3f,$3a,$3e,$3c,$39,$3b,$2a,$3d,$2e,$2b,$19,$2c

; --------------------------------
; reloc5bis

;	org $0c4a

bigmedal	= $07c0
;bigmedal	; $19
	db $2a,$2a,$3a,$4a,$4a
	db $2a,$2a,$3a,$4a,$4a
	db $1a,$1a,$2a,$3a,$3a
	db $0a,$0a,$1a,$2a,$2a
	db $0a,$0a,$1a,$2a,$2a	

; --------------------------------
; reloc3

;	org $0c63


tile_score	= $0708	
;tile_score	; $60
	db 0,0,0,0,0, 0,0,0
	db 0,0,0,0,2, 0,0,0
	db 0,0,0,0,4, 0,0,0
	db 0,0,0,0,8, 0,0,0
	db 0,0,0,1,6, 0,0,0
	db 0,0,0,3,2, 0,0,0
	db 0,0,0,6,4, 0,0,0
	db 0,1,0,2,8, 0,0,0
	db 0,0,2,5,6, 0,0,0
	db 0,0,5,1,2, 0,0,0
	db 0,1,0,2,4, 0,0,0
	db 0,2,0,4,8, 0,0,0
	
	include "key_constants.asm"
key_table	= $0768	
;key_table	; $4c	
	dw null
	;
	dw $0102, moveup		; joystick 1
	dw $0202, movedown
	dw $0402, moveleft
	dw $0802, moveright 
	;
	dw $0104, moveup		; joystick 2
	dw $0204, movedown
	dw $0404, moveleft
	dw $0804, moveright 
	;
	dw key_cursor_right, moveright	; cursor keys
	dw key_cursor_left, moveleft
	dw key_cursor_up, moveup
	dw key_cursor_down, movedown
	;
	dw key_f1, music_key
	dw key_f2, sfx_key
	dw key_esc, gameover
	;
	dw 0
skey_table	
	dw null
	dw key_space, rrepeat
	dw key_esc, rfile_close
	dw 0

; --------------------------------
; reloc1

;	org $0d0f
	
	include "octachars.asm"		

;	org $0e0f	
	
leftup		= $0337
rightup		= $0353
leftdown	= $0380
rightdown	= $039c
;; crossed tables in order to save space	
;	db $20,$20,$20,$20,$65	; $94
;;leftup
;	db $20,$20,$20,$20,$20,$20,$20,$55,$49,$55
;	db $20,$40,$49,$40,$49,$55,$40,$72,$49,$70 
;	db $49,$20,$20,$20,$20,$65
;;rightup	
;	db $20,$20,$20,$20,$20,$20,$20,$20,$20,$20
;	db $20,$20,$20,$20,$20,$67,$20,$20,$20,$20
;	db $20,$20,$20,$72,$49,$55,$49,$42,$21,$2e,$49
;	db $55,$55,$49,$20,$20,$20,$20,$20,$20,$20
;	db $67,$20,$20,$20,$20,$65	
;;leftdown
;	db $20,$20,$20,$20,$20,$20,$20,$4a,$4b,$4a
;	db $40,$40,$21,$4a,$71,$4a,$7d,$4a,$4b,$21
;	db $42,$20,$20,$20,$20,$65
;;rightdown
;	db $20,$20,$20,$20,$20,$20,$20,$20,$20,$20
;	db $20,$20,$20,$20,$20,$67,$20,$20,$20,$20
;	db $20,$20,$40,$71,$4b,$4a,$40,$4a,$4a,$4b,$4b
;	db $4a,$4a,$40,$20,$20,$20,$20,$20,$20,$20
;	db $67,$20,$20,$20,$20
	
; crossed tables in order to save space	
	db $e0,$e0,$e0,$e0,$c0	; $94
;leftup
	db $e0,$e0,$e0,$e0,$e0,$e0,$e0,$c3,$c5,$c3
	db $c7,$c9,$c5,$cb,$cd,$cf,$d1,$c3,$c5,$d3 
	db $d5,$e0,$e0,$e0,$e0,$c0
;rightup	
	db $e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0
	db $e0,$e0,$e0,$e0,$e0,$c1,$e0,$e0,$e0,$e0
	db $e0,$e0,$e0,$d3,$c5,$d7,$cd,$d9,$db,$dc,$dd
	db $df,$d7,$cd,$e0,$e0,$e0,$e0,$e0,$e0,$e0
	db $c1,$e0,$e0,$e0,$e0,$c0	
;leftdown
	db $e0,$e0,$e0,$e0,$e0,$e0,$e0,$c4,$c6,$c4
	db $c8,$e0,$ca,$cc,$ce,$d0,$d2,$c4,$c6,$d4
	db $ca,$e0,$e0,$e0,$e0,$c0
;rightdown
	db $e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0
	db $e0,$e0,$e0,$e0,$e0,$c1,$e0,$e0,$e0,$e0
	db $e0,$e0,$e0,$d6,$c6,$cc,$d8,$da,$c4,$c6,$de
	db $c2,$cc,$d8,$e0,$e0,$e0,$e0,$e0,$e0,$e0
	db $c1,$e0,$e0,$e0,$e0

tile_text	= $03c8
;tile_text	; $75
	db $07,$10,$11,$07,$12,$13,$07,$07,$07	; empty
	db $07,$14,$15,$07,$16,$17,$07,$18,$19	; 2
	db $07,$1a,$1b,$07,$1c,$1d,$07,$1e,$1f	; 4
	db $07,$20,$15,$07,$21,$22,$07,$23,$24	; 8
	db $25,$26,$27,$28,$29,$2a,$1e,$2b,$2c	; 16
	db $2d,$2e,$2f,$30,$31,$32,$33,$34,$35	; 32
	db $36,$37,$38,$39,$3a,$3b,$3c,$3d,$3e	; 64
	db $3f,$40,$41,$42,$43,$44,$45,$46,$23	; 128
	db $47,$48,$49,$4a,$4b,$4c,$4d,$4e,$23	; 256
	db $4f,$50,$51,$52,$53,$54,$4e,$55,$56	; 512
	db $57,$58,$59,$5a,$5b,$5c,$45,$5d,$5e	; 1024
	db $5f,$60,$61,$62,$63,$64,$65,$66,$67	; 2048
	db $07,$20,$15,$07,$c7,$22,$07,$23,$24	; 0

credits		= $043d
; credits	; $32	
	db $8f,$92,$89,$87,$89,$8e,$81,$8c,$ba,$a0,$83,$93,$81,$82,$8f,$af
	db $8c,$8f,$84,$ac,$80,$b2,$b0,$b1,$b4
	db $85,$8e,$88,$81,$8e,$83,$85,$84,$ba,$a0,$8c,$95,$83,$81,$af,$86
	db $89,$92,$85,$ac,$80,$b2,$b0,$b1,$b9

congratulations	= $046f
;congratulations; $11
	db "congratulations !"	

; --------------------------------
; reloc2

audio_text_color= $055c	
;audio_text_color; $0b			; reach lum5 by text cleaning
	db $47,$31,$34,$22,$22,$22,$22,$22,$22,$34,$31

tilemap		= $0567
; tilemap	; $10
	db 0,1,2,3,4,40,44,80,84,120,124,160,161,162,163,164

sublogo_flash	= $0577
;sublogo_flash	; $10
	db $1b,$2b,$3b,$39,$49,$5f,$6f,$6f,$7f,$7f,$7f,$79,$79,$79,$79,$79
	

pos_table	= $0587
;pos_table	; $20
	dw pos_corner + 0 * 240 + 0 * 6
	dw pos_corner + 0 * 240 + 1 * 6
	dw pos_corner + 0 * 240 + 2 * 6
	dw pos_corner + 0 * 240 + 3 * 6
	;
	dw pos_corner + 1 * 240 + 0 * 6
	dw pos_corner + 1 * 240 + 1 * 6
	dw pos_corner + 1 * 240 + 2 * 6
	dw pos_corner + 1 * 240 + 3 * 6
	;
	dw pos_corner + 2 * 240 + 0 * 6
	dw pos_corner + 2 * 240 + 1 * 6
	dw pos_corner + 2 * 240 + 2 * 6
	dw pos_corner + 2 * 240 + 3 * 6
	;
	dw pos_corner + 3 * 240 + 0 * 6
	dw pos_corner + 3 * 240 + 1 * 6
	dw pos_corner + 3 * 240 + 2 * 6
	dw pos_corner + 3 * 240 + 3 * 6

scoreaddsub	= $05a7
;scoreaddsub	; $0a
	db 0,0,0,0,0
score		= $05ac
	db 0,0,0,0,0

ribbon		= $05b1
;ribbon		; $0a
	db $2e,$3c,$3a,$3c,$2e
ribbondark	= $05b6
	db $1e,$1c,$0a,$1c,$1e		

enteryourname	= $05bb
;enteryourname	; $2c	
	db "   enter   "
	db " your name "
space9		= $05d1	
	db "           "
	db "  (     )  "
			
;	org $0fe8
shaketable
	db 3,$fd,3,$fd,3,$fd,3,$fd,2,$fe,2,$fe,1,$ff,1,$ff
	
debristable
	db $a0,$a7,$ba,$ae,$a0,$ae,$a1,$a7

;	org $1000
	db 0	; $1000!!	
	
	org $3800
charset	
	include "charset.asm"	

;eof
