	;
	; checkhighscore
	;
	; check if the score can get on the high score list.
	;
	; input:  variables "score" & "name"
	; return: x = 0-based position, or -1 if didn't make the list
	;	
checkhighscore
	jsr hs_ptr_reset		; reset pointer to beginning of high score data
	;
	ldx #$00
	;
chk0	ldy #$00
chk2	lda score,y			; compare the score to the high score table
	cmp (hs_ptr),y   
	bcc chk6			; if smaller, we're done, next score
	bne chk5			; if not equal (which means it's larger), then insert
	iny				; otherwise, if equal, then keep going
	cpy #hs_scorelen
	bne chk2
	;
chk5	; --- made the list!
	;
	rts				; return the position in x
	;
chk6	jsr hs_skip_one_record
	;
	inx
	cpx #hs_scores
	bne chk0
	;
	; --- did not get into high score
	;
	ldx #$ff			; return -1
chkr	rts
	;
	; inserthighscore
	;
	; check if the score can get on the high score list,
	; inserts score and name if needed.
	;
	; input:  variables "score" & "name"
	; return: a = 0-based position, or -1 if didn't make the list
	;	
inserthighscore
	jsr checkhighscore
	bmi chkr			; if didn't make the list, we're done
	;
	stx chk_temp			; store the rank
	dec chk_temp
	;
	cpx #hs_scores-1		; last place?
	beq chk11			; skip shifting down, just store it 
	;
chk8	cpx #hs_scores-2
	beq chk10
	;
	jsr hs_skip_one_record		; go to one before last record
	inx
	bne chk8
	;
chk7	lda hs_ptr			; move pointer back to previous record
	sec
	sbc #hs_namelen+hs_scorelen+1
	sta hs_ptr
	bcs *+4
	dec hs_ptr+1
	;	
chk10	ldy #$00
chk9	lda (hs_ptr),y			; copy one name+score forward
	pha				; save one byte
	tya
	clc
	adc #hs_namelen+hs_scorelen+1	; y = y + (record size)
	tay
	pla				; restore one byte
	sta (hs_ptr),y
	tya
	sec
	sbc #hs_namelen+hs_scorelen+1	; y = y - (record size)
	tay
	iny
	cpy #hs_namelen+hs_scorelen+1
	bne chk9
	;
	dex
	cpx chk_temp			; did we reach the rank?
	bne chk7
	;
	; --- finished pushing down scores
	;
hs_store_score_name
chk11	ldy #$00
chk3	lda score,y			; copy score
	sta (hs_ptr),y
	iny
	cpy #hs_scorelen
	bne chk3
	;
	tya
	jsr hs_ptr_add			; inc pointer
	;
	lda medal
	ldy #$00			; copy medal to 0
	sta (hs_ptr),y
	iny				; inc pointer
	tya
	jsr hs_ptr_add
	;
	ldy #$00			; copy name
chk4	lda name,y
	sta (hs_ptr),y
	iny
	cpy #hs_namelen
	bne chk4
	;
	rts
	
chk_temp
	db 0
		
hs_skip_one_record
	lda #hs_namelen+hs_scorelen+1	; skip name+score+medal
	;
hs_ptr_add
	clc
	adc hs_ptr
	sta hs_ptr
	bcc *+4
	inc hs_ptr+1
	rts

hs_ptr_reset	
	lda #hs_data & 255
	sta hs_ptr
	lda #hs_data >> 8
	sta hs_ptr+1
	;
	rts
;[eof]
