	jsr lfile_text
	;
; set as common JSR!
;        lda #hs_data & 255
;        sta $02
;        lda #hs_data >> 8
;        sta $03
        jsr set_hs_pointers
        ;
        lda #rfilename_end-rfilename
        ldx #rfilename & 255
        ldy #rfilename >> 8
        jsr $ffbd     ; call setnam
        lda #$02      ; file number 2
        ldx $ae       ; last used device number
        bne *+4
        ldx #$08      ; default to device 8
	ldy #$02      ; secondary address 2
        jsr $ffba     ; call setlfs
	jsr $ffc0     ; call open
        bcs rfile_error    ; if carry set, the file could not be opened     
;        
;        ; check drive error channel here to test for
;        ; file exists error etc.
;
        ldx #$02	; file number 2
        jsr $ffc6	; call chkout (file 2 now used as output)       

	ldy #$00
	jsr $ffcf	; 1st access does not sta a silly value
	sta garbage	; in ($02),y before being checked
	jsr $ffb7
	bne eof
	lda garbage
	sta ($02),y
rloop1	inc $02
        bne *+4
        inc $03
	jsr $ffb7     ; call readst (read status byte)
        bne eof	      ; either eof or read error
        jsr $ffcf     ; call chrin (get a byte from file)
        sta ($02),y   ; write byte to memory
	jmp rloop1    ; next byte
eof
        cmp #$40      ; end of file?
        bne readerror
rfile_close
        lda #$02      ; filenumber 2
        jsr $ffc3     ; call close
        jsr $ffcc     ; call clrchn
	rts
        ;
rfile_error
	cmp #$05
	bne general
	copygfx 3, 23, 37, 1, device_text
	copygfx 3, 24, 37, 1, keys_text
err1	jsr disk_off 
	lda #rkey_table & 255
	ldx #rkey_table >> 8
	jmp keyboard
general
	copygfx 3, 23, 37, 1, general_text
	copygfx 3, 24, 37, 1, keys_text
	jmp err1	

rrepeat	jsr rfile_close
	jmp loader		

	; most likely errors:
        ; a = $05 (device not present)
        ; a = $04 (file not found)
        ; a = $1d (load error)
        ; a = $00 (break, run/stop has been pressed during loading)
	
readerror
	lda $90
	cmp #$42
	bne err2 
	copygfx 3, 23, 37, 1, missing_text
	copygfx 3, 24, 37, 1, skeys_text
	jsr disk_off
	lda #rskey_table & 255
	ldx #rskey_table >> 8
	jmp keyboard
err2	
	copygfx 3, 23, 37, 1, loading_text
	copygfx 3, 24, 37, 1, keys_text
	jmp err1	
	
set_hs_pointers	
	lda #hs_data & 255
        sta $02
        lda #hs_data >> 8
        sta $03
        rts
        
lfile_text
	ldx #$4f
	lda #$19
	sta $0b98,x
	dex
	bpl lfile_text+4
	copygfx 3, 24, 37, 1, access_text
	jsr disk_on
	rts
	
disk_on	
	lda #$68
	sta $0f98
	lda #$69
	sta $0f99
	lda #$6a
	sta $0fc0
	lda #$6b
	sta $0fc1
	rts
	
disk_off	
	lda #$a0
	sta $0f98
	sta $0f99
	sta $0fc0
	sta $0fc1
	rts
	
reseths
	jsr rfile_close
	jsr saver
	rts
	
	cmap
	cmap " ",$a0,$a1,$a2,$a3,$a4,$a5
	cmap "'",$a7,$a8,$a9,$aa,$ab,$ac,$ad,$ae,$af,$b0,$b1,$b2,$b3,$b4,$b5,$b6,$b7,$b8,$b9,$ba,$bb
	cmap "=",$bd
	cmap "?",$bf
	cmap "a",$81,$82,$83,$84,$85,$86,$87,$88,$89,$8a,$8b,$8c,$8d,$8e,$8f,$90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9a

access_text
	db "accessing data, don't remove the disk"
device_text
	db "device not present                   "
keys_text	
	db "(space) to try again, (esc) to go on "
general_text
	db "error while opening the data file    "
loading_text
	db "error while reading the data file    "		
missing_text
	db "missing or bad data file, (esc) go on"
skeys_text	
	db "(space) to try again, (s) to reset hs"				        
garbage
       	db 0
rfilename
	cmap
	db "2048 OCTALUXE HS,S,R"  ; ,p,w is required to make this an output file!
rfilename_end

rskey_table
	dw null
	dw key_space, rrepeat
	dw key_esc, rfile_close
	dw key_s, reseths
	dw 0
	
rkey_table	
	dw null
	dw key_space, rrepeat
	dw key_esc, rfile_close
	dw 0
	