	;
	; string input routine
	;
	; let's the user input (type, edit) any string.
	;
stringinput
	jsr displaystring
	;
; modified to let the keys bleep!	
	lda #$02		; sfx: 4
	jsr ignite_sfx
	;
si_main	lda #inputkeys & 255
	ldx #inputkeys >> 8
	jmp keyboard 

si_return			; when return/enter is pressed, simply return (since all of this is a jsr call)
	rts
	;
	; --- typed one character
	;	
si_type
	ldy si_curpos		; check cursor position
	cpy si_maxlen		; to max size: are we at the end?
	beq si_main		; yes, buffer full, exit
	;
	jsr si_insert
	;
	lda keyb_shift		; was shift pressed?
	beq si07
	;
	txa
	clc
	adc #typedchars_end - typedchars
	tax
	;
si07	lda typedchars,x	; load keycode for pressed key
	sta si_string,y		; store the type character
	;
	inc si_curpos		; cursor goes forward
	;
	jmp stringinput		; update display and continue loop
	;
	; --- cursor right
	;	
si_right
	ldx si_curpos		; are we already at the end?
	cpx si_maxlen
	beq si_ret
	;
	inx			; cursor goes right
	bne si10		; always jump
	;
	; --- cursor left
	;
si_left
	ldx si_curpos		; are we already at the beginning?
	beq si_ret
	;
	dex			; cursor goes left
si10	stx si_curpos
	;
	jmp stringinput		; update display and continue loop
	;
si_ret	jmp si_main		; continue loop
	;
	; --- insert/delete
	;	
si_del
	lda keyb_shift		; check shift to determine if it's inst or del
	beq si13
	;
	ldy si_curpos		; check cursor position
	cpy si_maxlen		; to max size: are we at the end?
	beq si_ret
	;
	jsr si_insert		; inst!
	;
	lda #si_space
	sta si_string,y		; add a space
	;
	jmp stringinput		; update display and continue loop
	;
si13	ldx si_curpos		; cursor at beginning?
	beq si_ret
	bne si12
	;
si11	lda si_string,x
	sta si_string-1,x
	inx
si12	cpx si_maxlen
	bne si11
	;
	lda #si_space
	sta si_string-1,x
	;
	dec si_curpos
	;
	jmp stringinput		; update display and continue loop
	;
	; --- clear/home
	;	
si_home
	lda #$00
	sta si_curpos
	;
	lda keyb_shift
	beq si_h1
	;
	jsr stringinputclear 
	;
si_h1	jmp stringinput		; update display and continue loop
	;
	; "insert" one character at cursor position
	; return: y = current cursor position
	;
si_insert
	ldy si_maxlen		; copy next chars forward
	dey
	jmp si06
si05	dey
	lda si_string,y
	sta si_string+1,y
si06	cpy si_curpos
	bne si05
	;
	rts
	;
	; clear the input string buffer
	;
stringinputclear
	ldx #$00
	stx si_curpos
	;
	lda #si_space
sic	sta si_string,x
	inx
	cpx si_maxlen
	bne sic
	;
	rts  
	
	;
	; the following keys can be typed.
	; additional keys (e.g. numbers, etc) can be added.
	;
	cmap
	cmap " ",$a0,$a1,$a2,$a3,$a4,$a5
	cmap "'",$a7,$a8,$a9,$aa,$ab,$ac,$ad,$ae,$af,$b0,$b1,$b2,$b3,$b4,$b5,$b6,$b7,$b8,$b9,$ba,$bb
	cmap "=",$bd
	cmap "?",$bf
	cmap "a",$81,$82,$83,$84,$85,$86,$87,$88,$89,$8a,$8b,$8c,$8d,$8e,$8f,$90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9a
typedchars
	db " abcdefghijklmnopqrstuvwxyz.,+-/1234567890*="	; typed without shift
typedchars_end
	db " abcdefghijklmnopqrstuvwxyz.,+-?!",$a2,"#$%67()0*="	; typed with shift
	
inputkeys
	dw si_return
	;
	dw key_space, si_type
	dw key_a, si_type
	dw key_b, si_type
	dw key_c, si_type
	dw key_d, si_type
	dw key_e, si_type
	dw key_f, si_type
	dw key_g, si_type
	dw key_h, si_type
	dw key_i, si_type
	dw key_j, si_type
	dw key_k, si_type
	dw key_l, si_type
	dw key_m, si_type
	dw key_n, si_type
	dw key_o, si_type
	dw key_p, si_type
	dw key_q, si_type
	dw key_r, si_type
	dw key_s, si_type
	dw key_t, si_type
	dw key_u, si_type
	dw key_v, si_type
	dw key_w, si_type
	dw key_x, si_type
	dw key_y, si_type
	dw key_z, si_type
	dw key_dot, si_type
	dw key_comma, si_type
	dw key_plus, si_type
	dw key_minus, si_type
	dw key_slash, si_type
	dw key_1, si_type
	dw key_2, si_type
	dw key_3, si_type
	dw key_4, si_type
	dw key_5, si_type
	dw key_6, si_type
	dw key_7, si_type
	dw key_8, si_type
	dw key_9, si_type
	dw key_0, si_type
	dw key_star, si_type
	dw key_equals, si_type
	;
	dw key_cursor_right, si_right
	dw key_cursor_left, si_left
	dw key_inst_del, si_del
	dw key_clear_home, si_home
	dw key_return, si_return
	db 0
;[eof]
